-- name: [CS] Maurice
-- description: [CS] Maurice\nBy Quotation & SKL\n\nGoddamnit.\nVersion 1.2
-- deluxe: true
local globalModName = "Maurice";
local packVers = "1.2";

local E_MODEL_MAURICE = smlua_model_util_get_id("maurice_geo");
local MAURICE_SOUNDBANK = {
	--[CHAR_SOUND_OKEY_DOKEY] = 'MauriceOKIEDOKIE.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'MauriceLETSAGO.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'MauricePUNCHYAH.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'MauricePUNCHWAH.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'MauricePUNCHHOO.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'MauriceJUMPYAH.ogg', 'MauriceJUMPWAH.ogg', 'MauriceJUMPHOO.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'MauriceJUMPHOOHOO.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MauriceWAHA.ogg', 'MauriceYIPPEE.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'MauriceUH.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'MauriceUH2.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'MauriceUH2.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_OOOF] = 'MauriceOOOF.ogg', -- Pushed by a bully
	[CHAR_SOUND_OOOF2] = 'MauriceOOOF.ogg', -- Same as OOOF, landing after ejected from painting
	[CHAR_SOUND_HAHA] = 'MauriceHAHA.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'MauriceYAHOO.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'MauriceDOH.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'MauriceWHOA.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'MauriceEEUH.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'MauriceWAAAOOOW.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'MauriceTWIRLBOUNCE.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'MauriceGROUNDPOUNDWAH.ogg', 
	[CHAR_SOUND_HRMM] = 'MauriceHRMM.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'MauriceHEREWEGO.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'MauriceSOLONGABOWSER.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'MauriceATTACKED.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'MauricePANTING.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'MauriceONFIRE.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'MauriceIMATIRED.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'MauriceYAWN.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'MauriceSNORING1.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'MauriceSNORING2.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'MauriceSNORING3.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'MauriceCOUGHING.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'MauriceCOUGHING.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'MauriceCOUGHING.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'MauriceDYING.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'MauriceDROWNING.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'MauriceMAMMAMIA.ogg' -- Booted out of level
}

local MAURICE_CAPMODELS = { -- cap code
	normal = smlua_model_util_get_id("maurice_cap_geo"),
	wing = smlua_model_util_get_id("maurice_cap_wing_geo"),
	metal = smlua_model_util_get_id("maurice_cap_metal_geo"),
	metalWing = smlua_model_util_get_id("maurice_cap_metal_wing_geo"),
}
local MAURICE_PALETTE = {
	[PANTS] = "000000",
	[SHIRT] = "5bbf4f",
	[GLOVES] = "000000",
	[SHOES] = "000000",
	[HAIR] = "000000",
	[SKIN] = "ffaa83",
	[CAP] = "5bbf4f",
	[EMBLEM] = "5bbf4f"
}
local setHud = false;

local healthHUDTex = {
	label = {
		left = get_texture_info("M-healthhudback-left"),
		right = get_texture_info("M-healthhudback-right"),
	},	pie = {
		[8] = get_texture_info("M-slice8"),
		[7] = get_texture_info("M-slice7"),
		[6] = get_texture_info("M-slice6"),
		[5] = get_texture_info("M-slice5"),
		[4] = get_texture_info("M-slice4"),
		[3] = get_texture_info("M-slice3"),
		[2] = get_texture_info("M-slice2"),
		[1] = get_texture_info("M-slice1"),
	}
}

if _G.charSelectExists and SM64COOPDX_VERSION then
	-- DESCRIPTION & CREDITS
	if _G.charSelect.credit_add then
		_G.charSelect.credit_add(globalModName, "Quotation", "Programmer, modified model");
		_G.charSelect.credit_add(globalModName, "SuperKirbylover", "Programmer, original model");
		_G.charSelect.credit_add(globalModName, "ZAIDORZ", "Mixing");
		_G.charSelect.credit_add(globalModName, "ChipPotato", "Voice of Maurice");
	end
	local charNum = _G.charSelect.character_add("Maurice", {"From Pizza Tower", "", "Voiced by ChipPotato", "Version ".. packVers}, "Maurice", { r = 91, g = 191, b = 79 }, E_MODEL_MAURICE, CT_MARIO, get_texture_info("maurice_icon"));
	_G.charSelect.character_add_caps(E_MODEL_MAURICE, MAURICE_CAPMODELS); -- cap code
	_G.charSelect.character_add_voice(E_MODEL_MAURICE, MAURICE_SOUNDBANK);
	
	if _G.charSelect.character_add_palette_preset then -- adds preset palette
		_G.charSelect.character_add_palette_preset(E_MODEL_MAURICE, MAURICE_PALETTE);
	end
	if _G.charSelect.character_add_health_meter then -- adds custom health meter
		_G.charSelect.character_add_health_meter(charNum, healthHUDTex);
	end
	
	if _G.charSelect.dialog_set_replace_name then -- adds replacable names in dialogue
		_G.charSelect.dialog_set_replace_name("Maurice");
	end
	
	hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
		if _G.charSelect.character_get_voice(m) == MAURICE_SOUNDBANK then return _G.charSelect.voice.sound(m, sound) end
	end)
	hook_event(HOOK_MARIO_UPDATE, function (m)
		if _G.charSelect.character_get_voice(m) == MAURICE_SOUNDBANK then return _G.charSelect.voice.snore(m) end
	end)
	
	---@param m MarioState
	--[[hook_event(HOOK_MARIO_UPDATE, function(m)
		if m.playerIndex == 0 then -- if this is the localplayer
			if _G.charSelect.character_get_current_table().model == E_MODEL_MAURICE then -- if the player is playing as maurice
				if setHud == false then -- if the health HUD has not been set
					djui_chat_message_create("M: set hud");
					texture_override_set("texture_power_meter_left_side", healthHUDTex.pieBaseL);
					texture_override_set("texture_power_meter_right_side", healthHUDTex.pieBaseR);
					
					for i, tex in pairs(healthHUDTex.pizza) do
						texture_override_set("texture_power_meter_" .. i, tex);
					end
					
					setHud = true;
				end
			else
				if setHud == true then -- if it was previously set
					djui_chat_message_create("M: reset hud");
					texture_override_reset("texture_power_meter_left_side");
					texture_override_reset("texture_power_meter_right_side");
					
					for i, _ in pairs(healthHUDTex.pizza) do
						texture_override_reset("texture_power_meter_" .. i);
					end
					
					setHud = false;
				end
			end
		end
	end);]]
else
    djui_popup_create("\\#ffffdc\\\n"..globalModName.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end